// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'acTimer.pas' rev: 3.00

#ifndef acTimerHPP
#define acTimerHPP
#include <acClasses.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Actimer
{
//-- type declarations -------------------------------------------------------
typedef Set<Shortint, 0, 59>  TacCronSet;

enum TacCronGroups { crSec, crMin, crHour, crDay, crMonth, crDoW };

class DELPHICLASS TacCron;
class PASCALIMPLEMENTATION TacCron : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TacCronSet Groups[6];
	
public:
	void __fastcall Init( System::ShortString &CronMask);
	bool __fastcall IsCron(const _SYSTEMTIME &CheckTime);
public:
	/* TObject.Create */ __fastcall TacCron(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TacCron(void) { }
	
};

class DELPHICLASS TacCustomTimer;
class PASCALIMPLEMENTATION TacCustomTimer : public Acclasses::TacHandleComponent 
{
	typedef Acclasses::TacHandleComponent inherited;
	
private:
	bool FActive;
	Cardinal FAlertsCount;
	
protected:
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	void __fastcall Tick(void);
	virtual void __fastcall DoTimer(void);
	virtual bool __fastcall IsActive(void);
	
public:
	__fastcall virtual TacCustomTimer(Classes::TComponent* aOwner);
	__fastcall virtual ~TacCustomTimer(void);
	virtual void __fastcall Reset(void);
	__property bool Active = {read=FActive, write=FActive, default=1};
	__property Cardinal AlertsCount = {read=FAlertsCount, nodefault};
};

class DELPHICLASS TacCustomAccurateTimer;
class PASCALIMPLEMENTATION TacCustomAccurateTimer : public Actimer::TacCustomTimer 
{
	typedef Actimer::TacCustomTimer inherited;
	
private:
	Cardinal FCurrent;
	Classes::TNotifyEvent FOnTimer;
	
protected:
	Cardinal FInterval;
	virtual void __fastcall DoTimer(void);
	void __fastcall Update(Cardinal Increment);
	
public:
	__fastcall virtual TacCustomAccurateTimer(Classes::TComponent* aOwner);
	virtual void __fastcall Reset(void);
	__property Cardinal Interval = {read=FInterval, write=FInterval, default=1000};
	__property Classes::TNotifyEvent OnTimer = {read=FOnTimer, write=FOnTimer};
public:
	/* TacCustomTimer.Destroy */ __fastcall virtual ~TacCustomAccurateTimer(void) { }
	
};

class DELPHICLASS TacAccurateTimer;
class PASCALIMPLEMENTATION TacAccurateTimer : public Actimer::TacCustomAccurateTimer 
{
	typedef Actimer::TacCustomAccurateTimer inherited;
	
__published:
	__property Active ;
	__property Interval ;
	__property OnTimer ;
public:
	/* TacCustomAccurateTimer.Create */ __fastcall virtual TacAccurateTimer(Classes::TComponent* aOwner
		) : Actimer::TacCustomAccurateTimer(aOwner) { }
	
public:
	/* TacCustomTimer.Destroy */ __fastcall virtual ~TacAccurateTimer(void) { }
	
};

class DELPHICLASS TacCronJob;
class PASCALIMPLEMENTATION TacCronJob : public Actimer::TacCustomTimer 
{
	typedef Actimer::TacCustomTimer inherited;
	
private:
	System::AnsiString FCronMask;
	Classes::TNotifyEvent FOnAlert;
	TacCron* FCron;
	_SYSTEMTIME FLastCronTime;
	void __fastcall SetCronMask(const System::AnsiString Value);
	System::TDateTime __fastcall GetLastTime(void);
	
protected:
	virtual void __fastcall DoTimer(void);
	void __fastcall Update(const _SYSTEMTIME &CheckTime);
	
public:
	__fastcall virtual TacCronJob(Classes::TComponent* aOwner);
	__fastcall virtual ~TacCronJob(void);
	__property _SYSTEMTIME LastCronTime = {read=FLastCronTime};
	__property System::TDateTime LastTime = {read=GetLastTime};
	
__published:
	__property Active ;
	__property System::AnsiString CronMask = {read=FCronMask, write=SetCronMask};
	__property Classes::TNotifyEvent OnAlert = {read=FOnAlert, write=FOnAlert};
};

class DELPHICLASS TacTimerManager;
class PASCALIMPLEMENTATION TacTimerManager : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	Acclasses::TacThreadList* TimerList;
	Acclasses::TacThreadList* AlarmList;
	Cardinal LastTicks;
	Word LastSecond;
	
protected:
	virtual void __fastcall Execute(void);
	
public:
	__fastcall TacTimerManager(void);
	__fastcall virtual ~TacTimerManager(void);
	void __fastcall AddTimer(TacCustomTimer* Item);
	void __fastcall DeleteTimer(TacCustomTimer* Item, bool ReleaseInstance);
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TacTimerManager* TimerManager;

}	/* namespace Actimer */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Actimer;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// acTimer
